### 技术验证

先在木兰编程语言项目中进行试用，见[测试例程](https://gitee.com/MulanRevive/mulan-rework/blob/%E6%AD%A3%E5%88%99/%E6%B5%8B%E8%AF%95/unittest/%E6%AD%A3%E5%88%99.py#L37)。

### 设计思路

1. 尽可能减少底层 API 的数量，尽量保持与正则表达式语法的一一对应。至于有些符号如 ^ ? 等等有多种用处，需酌情看是否能合并到一个 API。 

2. 与 1 相关，底层 API 的功能尽量简单，不包含优化或者复杂的转换。

3. 命名风格上，尽量保持[术语一致](中英术语对照表.md)，避免同一字（词）在不同接口中含义不同。尽量使用两字或四字中文。用词尽量简单。

4. 设计上，通过链式调用尽量减少调用层级。尽量不将规律作为函数参数。

5. 如果允许字符串作“主语”，则不能后置方法，比如 `"abc".若干()`，因为 Python 不允许为内置类型添加方法。

### 正则常用语法的对应接口

***注：命名和设计尚在不断调整改进中***

- abc

  序列("abc")，允许多参数，等于各参数连接在一起

- ( 规律 )

  分段(规律)

- \n

  引用分段(序号)

- 规律1 | 规律2

  任一(规律1, 规律2)

- ^, $

  开头, 结尾

- 规律 *

  规律.若干()

- 规律 +

  规律.若干(1)，即重复一次以上

- 规律 {m}

  规律.若干(m)，即重复 m 次

- 规律 {m, n}

  规律.若干(m, n)，即重复 m 次到 n 次，必须 n>m，添加对应报错信息

- 规律 ?

  规律.可无()

- 规律 *?

  规律.若干().不贪() ？？何谓“不贪”

- 规律 +?

  规律.若干(1).不贪()

- 规律 {m, n}?

  规律.若干(m, n).不贪()

- [abc0-9]

  `某字("abc", 数字)`。这里原本用“一个”命名，但语义偏泛。

- [^abc]

  不是("abc")

- 规律2 (?= 规律1)

  规律2.后面是(规律1)

- 规律2 (?! 规律1)

  规律2.后面不是(规律1)

- (?<= 规律1) 规律2

  规律2.前面是(规律1)

- (?<! 规律1) 规律2

  规律2.前面不是(规律1)
